/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.datei.entity;

@javax.persistence.NamedQueries(
 {



   
 }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "SPALTENREIHENFOLGE")
// @javax.persistence.IdClass(SpaltenreihenfolgePK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Spaltenreihenfolge
implements SpaltenreihenfolgeBase
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Spaltenreihenfolge() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Spaltenreihenfolge(Spaltenreihenfolge original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "spaltenreihenfolge_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Spaltenreihenfolge")
    @javax.persistence.TableGenerator(name = "Spaltenreihenfolge", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Spaltenreihenfolge", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient SpaltenreihenfolgePK pkCache;

  @Override
  public SpaltenreihenfolgePK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new SpaltenreihenfolgePK(getId());
    }

    return pkCache;
  }

  public static <E extends Spaltenreihenfolge> java.util.Map<SpaltenreihenfolgePK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<SpaltenreihenfolgePK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Spaltenreihenfolge> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedNeuePosition = false;
          hasChangedOriginalPosition = false;
  
      hasChangedCsvDatei = false;
  


    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
      @javax.persistence.Column(name = "NEUE_POSITION", nullable = SpaltenreihenfolgeConstants.NEUE_POSITION_NULLABLE, precision=SpaltenreihenfolgeConstants.NEUE_POSITION_PRECISION, scale=SpaltenreihenfolgeConstants.NEUE_POSITION_SCALE)
            
  protected java.lang.Long neuePosition =  null;

  @javax.persistence.Transient
  protected boolean hasChangedNeuePosition = false;

  public boolean hasChangedNeuePosition(){
    return hasChangedNeuePosition;
  }
  
  /**
   * 
   *
   * getter for SPALTENREIHENFOLGE.NEUE_POSITION
   */
    @Override   public  java.lang.Long getNeuePosition() {
        return neuePosition;
      }

  /**
   * 
   *
   * setter for SPALTENREIHENFOLGE.NEUE_POSITION
   *
   * @param neuePosition
   */
  @Override   public void setNeuePosition( java.lang.Long neuePosition) {

       resetTkCache();
                  java.lang.Long neuePositionInternal = neuePosition;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.neuePosition
      , neuePositionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNeuePosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("neuePosition");
      }


      

       this.neuePosition = neuePositionInternal;

         }

        
      @javax.persistence.Column(name = "ORIGINAL_POSITION", nullable = SpaltenreihenfolgeConstants.ORIGINAL_POSITION_NULLABLE, precision=SpaltenreihenfolgeConstants.ORIGINAL_POSITION_PRECISION, scale=SpaltenreihenfolgeConstants.ORIGINAL_POSITION_SCALE)
            
  protected java.lang.Long originalPosition =  null;

  @javax.persistence.Transient
  protected boolean hasChangedOriginalPosition = false;

  public boolean hasChangedOriginalPosition(){
    return hasChangedOriginalPosition;
  }
  
  /**
   * 
   *
   * getter for SPALTENREIHENFOLGE.ORIGINAL_POSITION
   */
    @Override   public  java.lang.Long getOriginalPosition() {
        return originalPosition;
      }

  /**
   * 
   *
   * setter for SPALTENREIHENFOLGE.ORIGINAL_POSITION
   *
   * @param originalPosition
   */
  @Override   public void setOriginalPosition( java.lang.Long originalPosition) {

       resetTkCache();
                  java.lang.Long originalPositionInternal = originalPosition;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.originalPosition
      , originalPositionInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedOriginalPosition |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("originalPosition");
      }


      

       this.originalPosition = originalPositionInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu CsvDatei
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "CSV_DATEI_ID", referencedColumnName="DATEI_ID"))
  protected de.ivu.elect.business.datei.entity.CsvDatei csvDatei;

  /**
   * 
   */
  @Override
  public void setCsvDatei( de.ivu.elect.business.datei.entity.CsvDatei csvDatei){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.csvDatei
    , csvDatei);

    attributeChanged |= thisAttributChanged;

    hasChangedCsvDatei |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("csvDatei");
    }

    this.csvDatei = csvDatei;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.datei.entity.CsvDatei getCsvDatei(){
    return this.csvDatei;
  }

  @javax.persistence.Transient
  protected boolean hasChangedCsvDatei = false;

  public boolean hasChangedCsvDatei(){
    return hasChangedCsvDatei;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Spaltenreihenfolge:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Spaltenreihenfolge other){
                             other.neuePosition = this.neuePosition;
                                other.originalPosition = this.originalPosition;
           
  other.setCsvDatei(this.getCsvDatei());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Spaltenreihenfolge.class)){
        copyEntityAttributesUsingSetter((Spaltenreihenfolge) other.castTo(Spaltenreihenfolge.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Spaltenreihenfolge: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Spaltenreihenfolge other){
               other.setNeuePosition(this.neuePosition);
                  other.setOriginalPosition(this.originalPosition);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Spaltenreihenfolge other){
                       if (hasChangedNeuePosition) {
        other.setNeuePosition(this.neuePosition);
      }
                             if (hasChangedOriginalPosition) {
        other.setOriginalPosition(this.originalPosition);
      }
             }





    @javax.persistence.Transient
    private transient SpaltenreihenfolgeTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public SpaltenreihenfolgeTK getSpaltenreihenfolgeTK(){
    if (tkCache==null) {
    tkCache = new SpaltenreihenfolgeTK(



  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getSpaltenreihenfolgeTK();
    }

  @Override
  public SpaltenreihenfolgeUK getUk(){
    return getSpaltenreihenfolgeUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Spaltenreihenfolge.class;
  }

public SpaltenreihenfolgeUK getSpaltenreihenfolgeUK(){

   return  new SpaltenreihenfolgeUK(



  );
}

  @javax.persistence.Transient
  private transient SpaltenreihenfolgeProperties properties;

  public SpaltenreihenfolgeProperties getProperties(){
    if (properties == null) {
      properties = new SpaltenreihenfolgeProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public SpaltenreihenfolgeProperties getSpaltenreihenfolgeProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return SpaltenreihenfolgeConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return false;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
                         }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                                                    return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                                               }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "SPALTENREIHENFOLGE";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Spaltenreihenfolge";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(neuePosition, this, SpaltenreihenfolgeConstants.MESSAGE_KEY_NEUE_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(SpaltenreihenfolgeConstants.NEUE_POSITION_MAX_VALUE, SpaltenreihenfolgeConstants.NEUE_POSITION_MIN_VALUE, neuePosition, this, SpaltenreihenfolgeConstants.MESSAGE_KEY_NEUE_POSITION_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(originalPosition, this, SpaltenreihenfolgeConstants.MESSAGE_KEY_ORIGINAL_POSITION_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkValueRange(SpaltenreihenfolgeConstants.ORIGINAL_POSITION_MAX_VALUE, SpaltenreihenfolgeConstants.ORIGINAL_POSITION_MIN_VALUE, originalPosition, this, SpaltenreihenfolgeConstants.MESSAGE_KEY_ORIGINAL_POSITION_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
